// --- Generated by AidaCxxStub ---
#ifndef __SRVT__BSE_IDL
#define __SRVT__BSE_IDL


// --- ServerHH Boilerplate ---
#include <rapicorn-core.hh>

#include <rapicorn-core.hh> // for rcore/signal.hh

#define RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_EQ(Enum)   \
  bool constexpr operator== (Enum v, int64_t n) { return int64_t (v) == n; } \
  bool constexpr operator== (int64_t n, Enum v) { return n == int64_t (v); } \
  bool constexpr operator!= (Enum v, int64_t n) { return int64_t (v) != n; } \
  bool constexpr operator!= (int64_t n, Enum v) { return n != int64_t (v); }
#define RAPICORN_AIDA_FLAGS_DEFINE_ARITHMETIC_OPS(Enum)   \
  static constexpr int64_t operator>> (Enum v, int64_t n) { return int64_t (v) >> n; } \
  static constexpr int64_t operator<< (Enum v, int64_t n) { return int64_t (v) << n; } \
  static constexpr int64_t operator^  (Enum v, int64_t n) { return int64_t (v) ^ n; } \
  static constexpr int64_t operator^  (int64_t n, Enum v) { return n ^ int64_t (v); } \
  static constexpr int64_t operator|  (Enum v, int64_t n) { return int64_t (v) | n; } \
  static constexpr int64_t operator|  (int64_t n, Enum v) { return n | int64_t (v); } \
  static constexpr int64_t operator&  (Enum v, int64_t n) { return int64_t (v) & n; } \
  static constexpr int64_t operator&  (int64_t n, Enum v) { return n & int64_t (v); } \
  static constexpr int64_t operator~  (Enum v)            { return ~int64_t (v); } \
  static constexpr int64_t operator+  (Enum v)            { return +int64_t (v); } \
  static constexpr int64_t operator-  (Enum v)            { return -int64_t (v); } \
  static constexpr int64_t operator+  (Enum v, int64_t n) { return int64_t (v) + n; } \
  static constexpr int64_t operator+  (int64_t n, Enum v) { return n + int64_t (v); } \
  static constexpr int64_t operator-  (Enum v, int64_t n) { return int64_t (v) - n; } \
  static constexpr int64_t operator-  (int64_t n, Enum v) { return n - int64_t (v); } \
  static constexpr int64_t operator*  (Enum v, int64_t n) { return int64_t (v) * n; } \
  static constexpr int64_t operator*  (int64_t n, Enum v) { return n * int64_t (v); } \
  static constexpr int64_t operator/  (Enum v, int64_t n) { return int64_t (v) / n; } \
  static constexpr int64_t operator/  (int64_t n, Enum v) { return n / int64_t (v); } \
  static constexpr int64_t operator%  (Enum v, int64_t n) { return int64_t (v) % n; } \
  static constexpr int64_t operator%  (int64_t n, Enum v) { return n % int64_t (v); } \
  RAPICORN_FIXCYTHON_ENUM (Enum)
#ifdef     CYTHON_COMPILING_IN_CPYTHON
// Use C++ ADL, so PyInt_FromLong as generated by Cython works on scoped enums.
#define RAPICORN_FIXCYTHON_ENUM(Enum) \
  extern inline PyObject* PyInt_FromLong (Enum __e_) { return ::PyInt_FromLong (long (__e_)); }
#else  // !CYTHON_COMPILING_IN_CPYTHON
#define RAPICORN_FIXCYTHON_ENUM(Enum)
#endif // !CYTHON_COMPILING_IN_CPYTHON
#ifdef     RAPICORN_AIDA_ENABLE_ENUM_ARITHMETIC
#define RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_OPS        RAPICORN_AIDA_FLAGS_DEFINE_ARITHMETIC_OPS
#else  // !RAPICORN_AIDA_ENABLE_ENUM_ARITHMETIC
#define RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_OPS(Enum)  /* no arithmetic ops */
#endif // !RAPICORN_AIDA_ENABLE_ENUM_ARITHMETIC

#ifndef __ENUMHH__BSE_IDL__
#define __ENUMHH__BSE_IDL__

namespace Bse {

/// @cond GeneratedEnums
enum class Error : int64_t {
  NONE = 0, // _("OK")
  INTERNAL = 1, // _("Internal error (please report)")
  UNKNOWN = 2, // _("Unknown error")
  IO = 3, // _("Input/output error")
  PERMS = 4, // _("Insufficient permissions")
  FILE_BUSY = 5, // _("Device or resource busy")
  FILE_EXISTS = 6, // _("File exists already")
  FILE_EOF = 7, // _("End of file")
  FILE_EMPTY = 8, // _("File empty")
  FILE_NOT_FOUND = 9, // _("No such file, device or directory")
  FILE_IS_DIR = 10, // _("Is a directory")
  FILE_OPEN_FAILED = 11, // _("Open failed")
  FILE_SEEK_FAILED = 12, // _("Seek failed")
  FILE_READ_FAILED = 13, // _("Read failed")
  FILE_WRITE_FAILED = 14, // _("Write failed")
  MANY_FILES = 15, // _("Too many open files")
  NO_FILES = 16, // _("Too many open files in system")
  NO_SPACE = 17, // _("No space left on device")
  NO_MEMORY = 18, // _("Out of memory")
  NO_HEADER = 19, // _("Failed to detect header")
  NO_SEEK_INFO = 20, // _("Failed to retrieve seek information")
  NO_DATA = 21, // _("No data available")
  DATA_CORRUPT = 22, // _("Data corrupt")
  WRONG_N_CHANNELS = 23, // _("Wrong number of channels")
  FORMAT_INVALID = 24, // _("Invalid format")
  FORMAT_UNKNOWN = 25, // _("Unknown format")
  DATA_UNMATCHED = 26, // _("Requested data values unmatched")
  TEMP = 27, // _("Temporary error")
  WAVE_NOT_FOUND = 28, // _("No such wave")
  CODEC_FAILURE = 29, // _("Codec failure")
  UNIMPLEMENTED = 30, // _("Functionality not implemented")
  INVALID_PROPERTY = 31, // _("Invalid object property")
  INVALID_MIDI_CONTROL = 32, // _("Invalid MIDI control type")
  PARSE_ERROR = 33, // _("Parsing error")
  SPAWN = 34, // _("Failed to spawn child process")
  DEVICE_NOT_AVAILABLE = 35, // _("No device (driver) available")
  DEVICE_ASYNC = 36, // _("Device not async capable")
  DEVICE_BUSY = 37, // _("Device busy")
  DEVICE_FORMAT = 38, // _("Failed to configure device format")
  DEVICE_BUFFER = 39, // _("Failed to configure device buffer")
  DEVICE_LATENCY = 40, // _("Failed to configure device latency")
  DEVICE_CHANNELS = 41, // _("Failed to configure number of device channels")
  DEVICE_FREQUENCY = 42, // _("Failed to configure device frequency")
  DEVICES_MISMATCH = 43, // _("Device configurations mismatch")
  SOURCE_NO_SUCH_MODULE = 44, // _("No such synthesis module")
  SOURCE_NO_SUCH_ICHANNEL = 45, // _("No such input channel")
  SOURCE_NO_SUCH_OCHANNEL = 46, // _("No such output channel")
  SOURCE_NO_SUCH_CONNECTION = 47, // _("Input/Output channels not connected")
  SOURCE_PRIVATE_ICHANNEL = 48, // _("Input channel is private")
  SOURCE_ICHANNEL_IN_USE = 49, // _("Input channel already in use")
  SOURCE_CHANNELS_CONNECTED = 50, // _("Input/output channels already connected")
  SOURCE_CONNECTION_INVALID = 51, // _("Invalid synthesis module connection")
  SOURCE_PARENT_MISMATCH = 52, // _("Parent mismatch")
  SOURCE_BAD_LOOPBACK = 53, // _("Bad loopback")
  SOURCE_BUSY = 54, // _("Synthesis module currently busy")
  SOURCE_TYPE_INVALID = 55, // _("Invalid synthsis module type")
  PROC_NOT_FOUND = 56, // _("No such procedure")
  PROC_BUSY = 57, // _("Procedure currently busy")
  PROC_PARAM_INVAL = 58, // _("Procedure parameter invalid")
  PROC_EXECUTION = 59, // _("Procedure execution failed")
  PROC_ABORT = 60, // _("Procedure execution aborted")
  NO_ENTRY = 61, // _("No such entry")
  NO_EVENT = 62, // _("No such event")
  NO_TARGET = 63, // _("No target")
  NOT_OWNER = 64, // _("Ownership mismatch")
  INVALID_OFFSET = 65, // _("Invalid offset")
  INVALID_DURATION = 66, // _("Invalid duration")
  INVALID_OVERLAP = 67, // _("Invalid overlap")
};
inline void operator<<= (Rapicorn::Aida::ProtoMsg &__p_,  Error  e) { __p_ <<= Rapicorn::Aida::EnumValue (e); }
inline void operator>>= (Rapicorn::Aida::ProtoReader &__f_, Error &e) { e = Error (__f_.pop_evalue()); }
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_EQ (Error);
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_OPS (Error);
/// @endcond

/// @cond GeneratedEnums
enum class MidiSignal : int64_t {
  PROGRAM = 1,
  PRESSURE = 2,
  PITCH_BEND = 3,
  VELOCITY = 4,
  FINE_TUNE = 5,
  CONTINUOUS_0 = 64,
  CONTINUOUS_1 = 65,
  CONTINUOUS_2 = 66,
  CONTINUOUS_3 = 67,
  CONTINUOUS_4 = 68,
  CONTINUOUS_5 = 69,
  CONTINUOUS_6 = 70,
  CONTINUOUS_7 = 71,
  CONTINUOUS_8 = 72,
  CONTINUOUS_9 = 73,
  CONTINUOUS_10 = 74,
  CONTINUOUS_11 = 75,
  CONTINUOUS_12 = 76,
  CONTINUOUS_13 = 77,
  CONTINUOUS_14 = 78,
  CONTINUOUS_15 = 79,
  CONTINUOUS_16 = 80,
  CONTINUOUS_17 = 81,
  CONTINUOUS_18 = 82,
  CONTINUOUS_19 = 83,
  CONTINUOUS_20 = 84,
  CONTINUOUS_21 = 85,
  CONTINUOUS_22 = 86,
  CONTINUOUS_23 = 87,
  CONTINUOUS_24 = 88,
  CONTINUOUS_25 = 89,
  CONTINUOUS_26 = 90,
  CONTINUOUS_27 = 91,
  CONTINUOUS_28 = 92,
  CONTINUOUS_29 = 93,
  CONTINUOUS_30 = 94,
  CONTINUOUS_31 = 95,
  CONSTANT_HIGH = 96,
  CONSTANT_CENTER = 97,
  CONSTANT_LOW = 98,
  CONSTANT_NEGATIVE_CENTER = 99,
  CONSTANT_NEGATIVE_HIGH = 100,
  PARAMETER = 101,
  NON_PARAMETER = 102,
  CONTROL_0 = 128,
  CONTROL_1 = 129,
  CONTROL_2 = 130,
  CONTROL_3 = 131,
  CONTROL_4 = 132,
  CONTROL_5 = 133,
  CONTROL_6 = 134,
  CONTROL_7 = 135,
  CONTROL_8 = 136,
  CONTROL_9 = 137,
  CONTROL_10 = 138,
  CONTROL_11 = 139,
  CONTROL_12 = 140,
  CONTROL_13 = 141,
  CONTROL_14 = 142,
  CONTROL_15 = 143,
  CONTROL_16 = 144,
  CONTROL_17 = 145,
  CONTROL_18 = 146,
  CONTROL_19 = 147,
  CONTROL_20 = 148,
  CONTROL_21 = 149,
  CONTROL_22 = 150,
  CONTROL_23 = 151,
  CONTROL_24 = 152,
  CONTROL_25 = 153,
  CONTROL_26 = 154,
  CONTROL_27 = 155,
  CONTROL_28 = 156,
  CONTROL_29 = 157,
  CONTROL_30 = 158,
  CONTROL_31 = 159,
  CONTROL_32 = 160,
  CONTROL_33 = 161,
  CONTROL_34 = 162,
  CONTROL_35 = 163,
  CONTROL_36 = 164,
  CONTROL_37 = 165,
  CONTROL_38 = 166,
  CONTROL_39 = 167,
  CONTROL_40 = 168,
  CONTROL_41 = 169,
  CONTROL_42 = 170,
  CONTROL_43 = 171,
  CONTROL_44 = 172,
  CONTROL_45 = 173,
  CONTROL_46 = 174,
  CONTROL_47 = 175,
  CONTROL_48 = 176,
  CONTROL_49 = 177,
  CONTROL_50 = 178,
  CONTROL_51 = 179,
  CONTROL_52 = 180,
  CONTROL_53 = 181,
  CONTROL_54 = 182,
  CONTROL_55 = 183,
  CONTROL_56 = 184,
  CONTROL_57 = 185,
  CONTROL_58 = 186,
  CONTROL_59 = 187,
  CONTROL_60 = 188,
  CONTROL_61 = 189,
  CONTROL_62 = 190,
  CONTROL_63 = 191,
  CONTROL_64 = 192,
  CONTROL_65 = 193,
  CONTROL_66 = 194,
  CONTROL_67 = 195,
  CONTROL_68 = 196,
  CONTROL_69 = 197,
  CONTROL_70 = 198,
  CONTROL_71 = 199,
  CONTROL_72 = 200,
  CONTROL_73 = 201,
  CONTROL_74 = 202,
  CONTROL_75 = 203,
  CONTROL_76 = 204,
  CONTROL_77 = 205,
  CONTROL_78 = 206,
  CONTROL_79 = 207,
  CONTROL_80 = 208,
  CONTROL_81 = 209,
  CONTROL_82 = 210,
  CONTROL_83 = 211,
  CONTROL_84 = 212,
  CONTROL_85 = 213,
  CONTROL_86 = 214,
  CONTROL_87 = 215,
  CONTROL_88 = 216,
  CONTROL_89 = 217,
  CONTROL_90 = 218,
  CONTROL_91 = 219,
  CONTROL_92 = 220,
  CONTROL_93 = 221,
  CONTROL_94 = 222,
  CONTROL_95 = 223,
  CONTROL_96 = 224,
  CONTROL_97 = 225,
  CONTROL_98 = 226,
  CONTROL_99 = 227,
  CONTROL_100 = 228,
  CONTROL_101 = 229,
  CONTROL_102 = 230,
  CONTROL_103 = 231,
  CONTROL_104 = 232,
  CONTROL_105 = 233,
  CONTROL_106 = 234,
  CONTROL_107 = 235,
  CONTROL_108 = 236,
  CONTROL_109 = 237,
  CONTROL_110 = 238,
  CONTROL_111 = 239,
  CONTROL_112 = 240,
  CONTROL_113 = 241,
  CONTROL_114 = 242,
  CONTROL_115 = 243,
  CONTROL_116 = 244,
  CONTROL_117 = 245,
  CONTROL_118 = 246,
  CONTROL_119 = 247,
  CONTROL_120 = 248,
  CONTROL_121 = 249,
  CONTROL_122 = 250,
  CONTROL_123 = 251,
  CONTROL_124 = 252,
  CONTROL_125 = 253,
  CONTROL_126 = 254,
  CONTROL_127 = 255,
};
inline void operator<<= (Rapicorn::Aida::ProtoMsg &__p_,  MidiSignal  e) { __p_ <<= Rapicorn::Aida::EnumValue (e); }
inline void operator>>= (Rapicorn::Aida::ProtoReader &__f_, MidiSignal &e) { e = MidiSignal (__f_.pop_evalue()); }
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_EQ (MidiSignal);
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_OPS (MidiSignal);
/// @endcond

/// @cond GeneratedEnums
enum class MusicalTuning : int64_t {
  OD_12_TET = 1, // _("The most common tuning system for modern Western music, is the twelve-tone equal temperament, abbreviated as 12-TET, which divides the octave into 12 equal parts.")
  OD_7_TET = 2, // _("A fairly common tuning system is the seven-tone equal temperament tuning system, abbreviated as 7-TET. It divides the octave into 7 equal parts using 171 cent steps.")
  OD_5_TET = 3, // _("A fairly common tuning system is the five-tone equal temperament tuning system, abbreviated as 5-TET. It divides the octave into 5 equal parts using 240 cent steps.")
  DIATONIC_SCALE = 4, // _("In music theory, a diatonic scale (also: heptatonia prima) is a seven-note musical scale comprising five whole-tone and two half-tone steps. The half tones are maximally separated, so between two half-tone steps there are either two or three whole tones, repeating per octave.")
  INDIAN_SCALE = 5, // _("Diatonic scale used in Indian music with wolf interval at Dha, close to 3/2")
  PYTHAGOREAN_TUNING = 6, // _("Pythagorean tuning is the oldest way of tuning the 12-note chromatic scale, in which the frequency relationships of all intervals are based on the ratio 3:2. Its discovery is generally credited to Pythagoras.")
  PENTATONIC_5_LIMIT = 7, // _("Pentatonic scales are used in modern jazz and pop/rock contexts because they work exceedingly well over several chords diatonic to the same key, often better than the parent scale.")
  PENTATONIC_BLUES = 8, // _("The blues scale is the minor pentatonic with an additional augmented fourth, which is referred to as the \"blues note\".")
  PENTATONIC_GOGO = 9, // _("The Pentatonic Gogo scale is an anhemitonic pentatonic scale used to tune the instruments of the Gogo people of Tanzania.")
  QUARTER_COMMA_MEANTONE = 10, // _("Quarter-comma meantone was the most common meantone temperament in the sixteenth and seventeenth centuries and sometimes used later.")
  SILBERMANN_SORGE = 11, // _("The Silbermann-Sorge temperament is a meantone temperament used for Baroque era organs by Gottfried Silbermann.")
  WERCKMEISTER_3 = 12, // _("This tuning uses mostly pure (perfect) fifths, as in Pythagorean tuning, but each of the fifths C-G, G-D, D-A and B-F# is made smaller, i.e. tempered by 1/4 comma. Werckmeister designated this tuning as particularly suited for playing chromatic music.")
  WERCKMEISTER_4 = 13, // _("In this tuning the fifths C-G, D-A, E-B, F#-C#, and Bb-F are tempered narrow by 1/3 comma, and the fifths G#-D# and Eb-Bb are widened by 1/3 comma. The other fifths are pure. Most of its intervals are close to sixth-comma meantone. Werckmeister designed this tuning for playing mainly diatonic music.")
  WERCKMEISTER_5 = 14, // _("In this tuning the fifths D-A, A-E, F#-C#, C#-G#, and F-C are narrowed by 1/4 comma, and the fifth G#-D# is widened by 1/4 comma. The other fifths are pure. This temperament is closer to equal temperament than Werckmeister III or IV.")
  WERCKMEISTER_6 = 15, // _("This tuning is also known as Septenarius tuning is based on a division of the monochord length into 196 = 7 * 7 * 4 parts. The resulting scale has rational frequency relationships, but in practice involves pure and impure sounding fifths. Werckmeister described the Septenarius as a \"temperament which has nothing at all to do with the divisions of the comma, nevertheless in practice so correct that one can be really satisfied with it\".")
  KIRNBERGER_3 = 16, // _("Kirnberger's method of compensating for and closing the circle of fifths is to split the \"wolf\" interval known to those who have used meantone temperaments between four fifths instead, allowing for four 1/4-comma wolves to take their place. 1/4-comma wolves are used extensively in meantone and are much easier to tune and to listen to. Therefore, only one third remains pure (between C and E).")
  YOUNG = 17, // _("Thomas Young devised a form of musical tuning to make the harmony most perfect in those keys which are the most frequently used (give better major thirds in those keys), but to not have any unplayable keys. This is attempted by tuning upwards from C a sequence of six pure fourths, as well as six equally imperfect fifths.")
};
inline void operator<<= (Rapicorn::Aida::ProtoMsg &__p_,  MusicalTuning  e) { __p_ <<= Rapicorn::Aida::EnumValue (e); }
inline void operator>>= (Rapicorn::Aida::ProtoReader &__f_, MusicalTuning &e) { e = MusicalTuning (__f_.pop_evalue()); }
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_EQ (MusicalTuning);
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_OPS (MusicalTuning);
/// @endcond

/// @cond GeneratedEnums
enum class UserMessageType : int64_t {
  ERROR = 1,
  WARNING = 2,
  INFO = 3,
  DEBUG = 4,
};
inline void operator<<= (Rapicorn::Aida::ProtoMsg &__p_,  UserMessageType  e) { __p_ <<= Rapicorn::Aida::EnumValue (e); }
inline void operator>>= (Rapicorn::Aida::ProtoReader &__f_, UserMessageType &e) { e = UserMessageType (__f_.pop_evalue()); }
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_EQ (UserMessageType);
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_OPS (UserMessageType);
/// @endcond
} // Bse

namespace Rapicorn {

namespace Aida {
template<> const EnumInfo& enum_info<Bse::Error> ();
template<> const EnumInfo& enum_info<Bse::MidiSignal> ();
template<> const EnumInfo& enum_info<Bse::MusicalTuning> ();
template<> const EnumInfo& enum_info<Bse::UserMessageType> ();
} // Aida
} // Rapicorn

#endif // __ENUMHH__BSE_IDL__


// --- Interfaces (class declarations) ---

namespace Bse {

struct SrvT_StringSeq : public std::vector<std::string>
{
  typedef std::vector<std::string> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::StringSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_StringSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_StringSeq&);

struct SrvT_PixelSeq : public std::vector<int>
{
  typedef std::vector<int> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PixelSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_PixelSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_PixelSeq&);

struct SrvT_Icon
{
  /// @cond GeneratedFields
  int                           width;
  int                           height;
  SrvT_PixelSeq                 pixels;
  /// @endcond
  inline                        SrvT_Icon () { width = 0; height = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::Icon"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const SrvT_Icon &other) const;
  bool                          operator!=  (const SrvT_Icon &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (width, "width");
    _visitor_ (height, "height");
    _visitor_ (pixels, "pixels");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_Icon&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_Icon&);

struct SrvT_AuxData
{
  /// @cond GeneratedFields
  std::string                   entity;
  SrvT_StringSeq                attributes;
  /// @endcond
  inline                        SrvT_AuxData () { }
  std::string                   __aida_type_name__ () const	{ return "Bse::AuxData"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const SrvT_AuxData &other) const;
  bool                          operator!=  (const SrvT_AuxData &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (entity, "entity");
    _visitor_ (attributes, "attributes");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_AuxData&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_AuxData&);

struct SrvT_AuxDataSeq : public std::vector<SrvT_AuxData>
{
  typedef std::vector<SrvT_AuxData> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::AuxDataSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_AuxDataSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_AuxDataSeq&);

class TestObjectIface;
typedef std::shared_ptr<TestObjectIface> TestObjectIfaceP;
typedef std::weak_ptr  <TestObjectIface> TestObjectIfaceW;

/** @interface TestObject
 * See also the corresponding C++ servant class TestObjectIface. */
/// See also the corresponding IDL class TestObject.
class TestObjectIface : public virtual Rapicorn::Aida::ImplicitBase
{
protected:
  explicit                               TestObjectIface ();
  virtual /*Des*/                       ~TestObjectIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::TestObject"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  typedef Rapicorn::Aida::Signal<void (const std::string &msg)> Signal_echo_reply;
  Signal_echo_reply sig_echo_reply;
  virtual int                           echo_test       (const std::string &msg) = 0; 	///< See TestObject::echo_test()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {}
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const TestObjectIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, TestObjectIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, TestObjectIfaceP&);

struct SrvT_UserMessage
{
  /// @cond GeneratedFields
  UserMessageType               utype;
  std::string                   title;
  std::string                   text1;
  std::string                   text2;
  std::string                   text3;
  std::string                   label;
  /// @endcond
  inline                        SrvT_UserMessage () { utype = UserMessageType (0); }
  std::string                   __aida_type_name__ () const	{ return "Bse::UserMessage"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const SrvT_UserMessage &other) const;
  bool                          operator!=  (const SrvT_UserMessage &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (utype, "utype");
    _visitor_ (title, "title");
    _visitor_ (text1, "text1");
    _visitor_ (text2, "text2");
    _visitor_ (text3, "text3");
    _visitor_ (label, "label");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_UserMessage&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_UserMessage&);

struct SrvT_SongTiming
{
  /// @cond GeneratedFields
  int                           tick;
  double                        bpm;
  int                           numerator;
  int                           denominator;
  int                           tpqn;
  int                           tpt;
  double                        stamp_ticks;
  /// @endcond
  inline                        SrvT_SongTiming () { tick = 0; bpm = 0; numerator = 0; denominator = 0; tpqn = 0; tpt = 0; stamp_ticks = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::SongTiming"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const SrvT_SongTiming &other) const;
  bool                          operator!=  (const SrvT_SongTiming &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (tick, "tick");
    _visitor_ (bpm, "bpm");
    _visitor_ (numerator, "numerator");
    _visitor_ (denominator, "denominator");
    _visitor_ (tpqn, "tpqn");
    _visitor_ (tpt, "tpt");
    _visitor_ (stamp_ticks, "stamp_ticks");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_SongTiming&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_SongTiming&);

struct SrvT_NoteDescription
{
  /// @cond GeneratedFields
  MusicalTuning                 musical_tuning;
  int                           note;
  int                           octave;
  double                        freq;
  int                           finetune;
  int                           semitone;
  bool                          upshift;
  int                           letter;
  std::string                   name;
  /// @endcond
  inline                        SrvT_NoteDescription () { musical_tuning = MusicalTuning (0); note = 0; octave = 0; freq = 0; finetune = 0; semitone = 0; upshift = 0; letter = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::NoteDescription"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const SrvT_NoteDescription &other) const;
  bool                          operator!=  (const SrvT_NoteDescription &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (musical_tuning, "musical_tuning");
    _visitor_ (note, "note");
    _visitor_ (octave, "octave");
    _visitor_ (freq, "freq");
    _visitor_ (finetune, "finetune");
    _visitor_ (semitone, "semitone");
    _visitor_ (upshift, "upshift");
    _visitor_ (letter, "letter");
    _visitor_ (name, "name");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_NoteDescription&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_NoteDescription&);

class SrvT_PartLink;

class SrvT_PartLinkSeq;

class SrvT_TrackPart;

class SrvT_TrackPartSeq;

class ObjectIface;
typedef std::shared_ptr<ObjectIface> ObjectIfaceP;
typedef std::weak_ptr  <ObjectIface> ObjectIfaceW;

/** @interface Object
 * See also the corresponding C++ servant class ObjectIface. */
/// See also the corresponding IDL class Object.
class ObjectIface : public virtual Rapicorn::Aida::ImplicitBase
{
protected:
  explicit                               ObjectIface ();
  virtual /*Des*/                       ~ObjectIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::Object"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  typedef Rapicorn::Aida::Signal<void (const std::string &what)> Signal_changed;
  Signal_changed sig_changed;
  virtual std::string                   debug_name  () = 0; 	///< See Object::debug_name()
  virtual int64_t                       proxy_id    () = 0; 	///< See Object::proxy_id()
  // class_scope:Object:
  // as<BseObjectPtr>()
  template<class BseObjectPtr, typename ::std::enable_if<std::is_pointer<BseObjectPtr>::value, bool>::type = true>
  BseObjectPtr           as ()
  {
    static_assert (std::is_pointer<BseObjectPtr>::value, "'BseObject*' required");
    typedef typename std::remove_pointer<BseObjectPtr>::type BseObjectT;
    static_assert (std::is_base_of<GObject, BseObjectT>::value, "'BseObject*' required");
    return this ? (BseObjectPtr) this->as_bse_object() : NULL;
  }
  // DERIVES_shared_ptr (uses void_t to prevent errors for T without shared_ptr's typedefs)
  template<class T, typename = void> struct DERIVES_shared_ptr : std::false_type {};
  template<class T> struct DERIVES_shared_ptr<T, Rapicorn::void_t< typename T::element_type > > :
  std::is_base_of< std::shared_ptr<typename T::element_type>, T > {};
  // as<shared_ptr<T>>()
  template<class ObjectImplP, typename ::std::enable_if<DERIVES_shared_ptr<ObjectImplP>::value, bool>::type = true>
  ObjectImplP            as ()
  {
    typedef typename ObjectImplP::element_type ObjectImplT;
    static_assert (std::is_base_of<Rapicorn::Aida::ImplicitBase, ObjectImplT>::value, "");
    ObjectImplT *impl = this ? dynamic_cast<ObjectImplT*> (this) : NULL;
    return impl ? Rapicorn::shared_ptr_cast<ObjectImplT> (impl) : NULL;
  }
protected:
  virtual BseObject* as_bse_object() = 0;
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {}
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ObjectIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ObjectIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ObjectIfaceP&);

class ItemIface;
typedef std::shared_ptr<ItemIface> ItemIfaceP;
typedef std::weak_ptr  <ItemIface> ItemIfaceW;

/** @interface Item
 * See also the corresponding C++ servant class ItemIface. */
/// See also the corresponding IDL class Item.
class ItemIface : public virtual ObjectIface
{
protected:
  explicit                               ItemIface ();
  virtual /*Des*/                       ~ItemIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::Item"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  virtual SrvT_Icon                     icon () const = 0; 	///< See Item::icon
  virtual void                          icon (const SrvT_Icon&) = 0; 	///< See Item::icon
  virtual ItemIfaceP                    common_ancestor (ItemIface &other) = 0; 	///< See Item::common_ancestor()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    __visitor_ (*this, "icon", &ItemIface::icon, &ItemIface::icon);
    this->ObjectIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ItemIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ItemIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ItemIfaceP&);

struct SrvT_PartNote
{
  /// @cond GeneratedFields
  int                           id;
  int                           channel;
  int                           tick;
  int                           duration;
  int                           note;
  int                           fine_tune;
  double                        velocity;
  bool                          selected;
  /// @endcond
  inline                        SrvT_PartNote () { id = 0; channel = 0; tick = 0; duration = 0; note = 0; fine_tune = 0; velocity = 0; selected = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartNote"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const SrvT_PartNote &other) const;
  bool                          operator!=  (const SrvT_PartNote &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (id, "id");
    _visitor_ (channel, "channel");
    _visitor_ (tick, "tick");
    _visitor_ (duration, "duration");
    _visitor_ (note, "note");
    _visitor_ (fine_tune, "fine_tune");
    _visitor_ (velocity, "velocity");
    _visitor_ (selected, "selected");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_PartNote&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_PartNote&);

struct SrvT_PartNoteSeq : public std::vector<SrvT_PartNote>
{
  typedef std::vector<SrvT_PartNote> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartNoteSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_PartNoteSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_PartNoteSeq&);

struct SrvT_PartControl
{
  /// @cond GeneratedFields
  int                           id;
  int                           tick;
  MidiSignal                    control_type;
  double                        value;
  bool                          selected;
  /// @endcond
  inline                        SrvT_PartControl () { id = 0; tick = 0; control_type = MidiSignal (0); value = 0; selected = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartControl"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const SrvT_PartControl &other) const;
  bool                          operator!=  (const SrvT_PartControl &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (id, "id");
    _visitor_ (tick, "tick");
    _visitor_ (control_type, "control_type");
    _visitor_ (value, "value");
    _visitor_ (selected, "selected");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_PartControl&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_PartControl&);

struct SrvT_PartControlSeq : public std::vector<SrvT_PartControl>
{
  typedef std::vector<SrvT_PartControl> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartControlSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_PartControlSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_PartControlSeq&);

class PartIface;
typedef std::shared_ptr<PartIface> PartIfaceP;
typedef std::weak_ptr  <PartIface> PartIfaceW;

/** @interface Part
 * See also the corresponding C++ servant class PartIface. */
/// See also the corresponding IDL class Part.
class PartIface : public virtual ItemIface
{
protected:
  explicit                               PartIface ();
  virtual /*Des*/                       ~PartIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::Part"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  virtual SrvT_PartControlSeq           list_selected_controls    (MidiSignal control_type) = 0; 	///< See Part::list_selected_controls()
  virtual SrvT_PartControlSeq           list_controls             (int tick,
                                                                   int duration,
                                                                   MidiSignal control_type) = 0; 	///< See Part::list_controls()
  virtual SrvT_PartControlSeq           get_channel_controls      (int channel,
                                                                   int tick,
                                                                   int duration,
                                                                   MidiSignal control_type) = 0; 	///< See Part::get_channel_controls()
  virtual SrvT_PartControlSeq           get_controls              (int tick,
                                                                   MidiSignal control_type) = 0; 	///< See Part::get_controls()
  virtual SrvT_SongTiming               get_timing                (int tick) = 0; 	///< See Part::get_timing()
  virtual int                           get_max_note              () = 0; 	///< See Part::get_max_note()
  virtual int                           get_min_note              () = 0; 	///< See Part::get_min_note()
  virtual Error                         change_control            (int id,
                                                                   int tick,
                                                                   MidiSignal control_type,
                                                                   double value) = 0; 	///< See Part::change_control()
  virtual Error                         change_note               (int id,
                                                                   int tick,
                                                                   int duration,
                                                                   int note,
                                                                   int fine_tune,
                                                                   double velocity) = 0; 	///< See Part::change_note()
  virtual Error                         delete_event              (int id) = 0; 	///< See Part::delete_event()
  virtual int                           insert_control            (int tick,
                                                                   MidiSignal control_type,
                                                                   double value) = 0; 	///< See Part::insert_control()
  virtual int                           insert_note               (int channel,
                                                                   int tick,
                                                                   int duration,
                                                                   int note,
                                                                   int fine_tune,
                                                                   double velocity) = 0; 	///< See Part::insert_note()
  virtual int                           insert_note_auto          (int tick,
                                                                   int duration,
                                                                   int note,
                                                                   int fine_tune,
                                                                   double velocity) = 0; 	///< See Part::insert_note_auto()
  virtual bool                          is_event_selected         (int id) = 0; 	///< See Part::is_event_selected()
  virtual void                          queue_controls            (int tick,
                                                                   int duration) = 0; 	///< See Part::queue_controls()
  virtual void                          queue_notes               (int tick,
                                                                   int duration,
                                                                   int min_note,
                                                                   int max_note) = 0; 	///< See Part::queue_notes()
  virtual void                          select_notes_exclusive    (int tick,
                                                                   int duration,
                                                                   int min_note,
                                                                   int max_note) = 0; 	///< See Part::select_notes_exclusive()
  virtual void                          select_controls_exclusive (int tick,
                                                                   int duration,
                                                                   MidiSignal control_type) = 0; 	///< See Part::select_controls_exclusive()
  virtual void                          select_notes              (int tick,
                                                                   int duration,
                                                                   int min_note,
                                                                   int max_note) = 0; 	///< See Part::select_notes()
  virtual void                          select_event              (int id) = 0; 	///< See Part::select_event()
  virtual void                          select_controls           (int tick,
                                                                   int duration,
                                                                   MidiSignal control_type) = 0; 	///< See Part::select_controls()
  virtual void                          deselect_notes            (int tick,
                                                                   int duration,
                                                                   int min_note,
                                                                   int max_note) = 0; 	///< See Part::deselect_notes()
  virtual void                          deselect_event            (int id) = 0; 	///< See Part::deselect_event()
  virtual void                          deselect_controls         (int tick,
                                                                   int duration,
                                                                   MidiSignal control_type) = 0; 	///< See Part::deselect_controls()
  virtual SrvT_PartNoteSeq              list_notes_crossing       (int tick,
                                                                   int duration) = 0; 	///< See Part::list_notes_crossing()
  virtual SrvT_PartNoteSeq              list_notes_within         (int channel,
                                                                   int tick,
                                                                   int duration) = 0; 	///< See Part::list_notes_within()
  virtual SrvT_PartNoteSeq              list_selected_notes       () = 0; 	///< See Part::list_selected_notes()
  virtual SrvT_PartNoteSeq              check_overlap             (int tick,
                                                                   int duration,
                                                                   int note) = 0; 	///< See Part::check_overlap()
  virtual SrvT_PartNoteSeq              get_notes                 (int tick,
                                                                   int note) = 0; 	///< See Part::get_notes()
  virtual SrvT_PartLinkSeq              list_links                () = 0; 	///< See Part::list_links()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const PartIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, PartIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, PartIfaceP&);

struct SrvT_PartSeq : public std::vector<PartIfaceP>
{
  typedef std::vector<PartIfaceP> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_PartSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_PartSeq&);

class SourceIface;
typedef std::shared_ptr<SourceIface> SourceIfaceP;
typedef std::weak_ptr  <SourceIface> SourceIfaceW;

/** @interface Source
 * See also the corresponding C++ servant class SourceIface. */
/// See also the corresponding IDL class Source.
class SourceIface : public virtual ItemIface
{
protected:
  explicit                               SourceIface ();
  virtual /*Des*/                       ~SourceIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::Source"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  virtual SourceIfaceP                  ichannel_get_osource (int input_channel,
                                                              int input_joint) = 0; 	///< See Source::ichannel_get_osource()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SourceIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SourceIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SourceIfaceP&);

class ContextMergerIface;
typedef std::shared_ptr<ContextMergerIface> ContextMergerIfaceP;
typedef std::weak_ptr  <ContextMergerIface> ContextMergerIfaceW;

/** @interface ContextMerger
 * See also the corresponding C++ servant class ContextMergerIface. */
/// See also the corresponding IDL class ContextMerger.
class ContextMergerIface : public virtual SourceIface
{
protected:
  explicit                               ContextMergerIface ();
  virtual /*Des*/                       ~ContextMergerIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::ContextMerger"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SourceIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ContextMergerIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ContextMergerIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ContextMergerIfaceP&);

class ContainerIface;
typedef std::shared_ptr<ContainerIface> ContainerIfaceP;
typedef std::weak_ptr  <ContainerIface> ContainerIfaceW;

/** @interface Container
 * See also the corresponding C++ servant class ContainerIface. */
/// See also the corresponding IDL class Container.
class ContainerIface : public virtual SourceIface
{
protected:
  explicit                               ContainerIface ();
  virtual /*Des*/                       ~ContainerIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::Container"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  virtual ItemIfaceP                    lookup_item    (const std::string &uname) = 0; 	///< See Container::lookup_item()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SourceIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ContainerIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ContainerIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ContainerIfaceP&);

class SuperIface;
typedef std::shared_ptr<SuperIface> SuperIfaceP;
typedef std::weak_ptr  <SuperIface> SuperIfaceW;

/** @interface Super
 * See also the corresponding C++ servant class SuperIface. */
/// See also the corresponding IDL class Super.
class SuperIface : public virtual ContainerIface
{
protected:
  explicit                               SuperIface ();
  virtual /*Des*/                       ~SuperIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::Super"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ContainerIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SuperIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SuperIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SuperIfaceP&);

class SNetIface;
typedef std::shared_ptr<SNetIface> SNetIfaceP;
typedef std::weak_ptr  <SNetIface> SNetIfaceW;

/** @interface SNet
 * See also the corresponding C++ servant class SNetIface. */
/// See also the corresponding IDL class SNet.
class SNetIface : public virtual SuperIface
{
protected:
  explicit                               SNetIface ();
  virtual /*Des*/                       ~SNetIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::SNet"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  virtual bool                          auto_activate () const = 0; 	///< See SNet::auto_activate
  virtual void                          auto_activate (bool) = 0; 	///< See SNet::auto_activate
  typedef Rapicorn::Aida::Signal<void ()> Signal_port_unregistered;
  Signal_port_unregistered sig_port_unregistered;
  virtual bool                          supports_user_synths () = 0; 	///< See SNet::supports_user_synths()
  virtual Error                         can_create_source    (const std::string &module_type) = 0; 	///< See SNet::can_create_source()
  virtual SourceIfaceP                  create_source        (const std::string &module_type) = 0; 	///< See SNet::create_source()
  virtual Error                         remove_source        (SourceIface &module) = 0; 	///< See SNet::remove_source()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    __visitor_ (*this, "auto_activate", &SNetIface::auto_activate, &SNetIface::auto_activate);
    this->SuperIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SNetIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SNetIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SNetIfaceP&);

class CSynthIface;
typedef std::shared_ptr<CSynthIface> CSynthIfaceP;
typedef std::weak_ptr  <CSynthIface> CSynthIfaceW;

/** @interface CSynth
 * See also the corresponding C++ servant class CSynthIface. */
/// See also the corresponding IDL class CSynth.
class CSynthIface : public virtual SNetIface
{
protected:
  explicit                               CSynthIface ();
  virtual /*Des*/                       ~CSynthIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::CSynth"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SNetIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const CSynthIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, CSynthIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, CSynthIfaceP&);

class SubSynthIface;
typedef std::shared_ptr<SubSynthIface> SubSynthIfaceP;
typedef std::weak_ptr  <SubSynthIface> SubSynthIfaceW;

/** @interface SubSynth
 * See also the corresponding C++ servant class SubSynthIface. */
/// See also the corresponding IDL class SubSynth.
class SubSynthIface : public virtual SourceIface
{
protected:
  explicit                               SubSynthIface ();
  virtual /*Des*/                       ~SubSynthIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::SubSynth"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SourceIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SubSynthIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SubSynthIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SubSynthIfaceP&);

class TrackIface;
typedef std::shared_ptr<TrackIface> TrackIfaceP;
typedef std::weak_ptr  <TrackIface> TrackIfaceW;

/** @interface Track
 * See also the corresponding C++ servant class TrackIface. */
/// See also the corresponding IDL class Track.
class TrackIface : public virtual ContextMergerIface
{
protected:
  explicit                               TrackIface ();
  virtual /*Des*/                       ~TrackIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::Track"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  virtual SrvT_SongTiming               get_timing        (int tick) = 0; 	///< See Track::get_timing()
  virtual int                           insert_part       (int tick,
                                                           PartIface &part) = 0; 	///< See Track::insert_part()
  virtual void                          remove_tick       (int tick) = 0; 	///< See Track::remove_tick()
  virtual void                          remove_link       (int id) = 0; 	///< See Track::remove_link()
  virtual SrvT_PartSeq                  list_parts_uniq   () = 0; 	///< See Track::list_parts_uniq()
  virtual SrvT_TrackPartSeq             list_parts        () = 0; 	///< See Track::list_parts()
  virtual PartIfaceP                    get_part          (int tick) = 0; 	///< See Track::get_part()
  virtual int                           get_last_tick     () = 0; 	///< See Track::get_last_tick()
  virtual Error                         ensure_output     () = 0; 	///< See Track::ensure_output()
  virtual SourceIfaceP                  get_output_source () = 0; 	///< See Track::get_output_source()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ContextMergerIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const TrackIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, TrackIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, TrackIfaceP&);

struct SrvT_PartLink
{
  /// @cond GeneratedFields
  TrackIfaceP                   track;
  int                           tick;
  PartIfaceP                    part;
  int                           duration;
  /// @endcond
  inline                        SrvT_PartLink () { tick = 0; duration = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartLink"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const SrvT_PartLink &other) const;
  bool                          operator!=  (const SrvT_PartLink &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (track, "track");
    _visitor_ (tick, "tick");
    _visitor_ (part, "part");
    _visitor_ (duration, "duration");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_PartLink&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_PartLink&);

struct SrvT_PartLinkSeq : public std::vector<SrvT_PartLink>
{
  typedef std::vector<SrvT_PartLink> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartLinkSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_PartLinkSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_PartLinkSeq&);

struct SrvT_TrackPart
{
  /// @cond GeneratedFields
  int                           tick;
  PartIfaceP                    part;
  int                           duration;
  /// @endcond
  inline                        SrvT_TrackPart () { tick = 0; duration = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::TrackPart"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const SrvT_TrackPart &other) const;
  bool                          operator!=  (const SrvT_TrackPart &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (tick, "tick");
    _visitor_ (part, "part");
    _visitor_ (duration, "duration");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_TrackPart&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_TrackPart&);

struct SrvT_TrackPartSeq : public std::vector<SrvT_TrackPart>
{
  typedef std::vector<SrvT_TrackPart> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::TrackPartSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_TrackPartSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_TrackPartSeq&);

class BusIface;
typedef std::shared_ptr<BusIface> BusIfaceP;
typedef std::weak_ptr  <BusIface> BusIfaceW;

/** @interface Bus
 * See also the corresponding C++ servant class BusIface. */
/// See also the corresponding IDL class Bus.
class BusIface : public virtual SubSynthIface
{
protected:
  explicit                               BusIface ();
  virtual /*Des*/                       ~BusIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::Bus"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  virtual Error                         ensure_output    () = 0; 	///< See Bus::ensure_output()
  virtual Error                         connect_bus      (BusIface &bus) = 0; 	///< See Bus::connect_bus()
  virtual Error                         connect_track    (TrackIface &track) = 0; 	///< See Bus::connect_track()
  virtual Error                         disconnect_bus   (BusIface &bus) = 0; 	///< See Bus::disconnect_bus()
  virtual Error                         disconnect_track (TrackIface &track) = 0; 	///< See Bus::disconnect_track()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SubSynthIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const BusIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, BusIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, BusIfaceP&);

class SongIface;
typedef std::shared_ptr<SongIface> SongIfaceP;
typedef std::weak_ptr  <SongIface> SongIfaceW;

/** @interface Song
 * See also the corresponding C++ servant class SongIface. */
/// See also the corresponding IDL class Song.
class SongIface : public virtual SNetIface
{
protected:
  explicit                               SongIface ();
  virtual /*Des*/                       ~SongIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::Song"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  virtual double                        bpm            () const = 0; 	///< See Song::bpm
  virtual void                          bpm            (double) = 0; 	///< See Song::bpm
  virtual MusicalTuning                 musical_tuning () const = 0; 	///< See Song::musical_tuning
  virtual void                          musical_tuning (MusicalTuning) = 0; 	///< See Song::musical_tuning
  virtual SrvT_SongTiming               get_timing              (int tick) = 0; 	///< See Song::get_timing()
  virtual TrackIfaceP                   find_any_track_for_part (PartIface &part) = 0; 	///< See Song::find_any_track_for_part()
  virtual BusIfaceP                     create_bus              () = 0; 	///< See Song::create_bus()
  virtual void                          remove_bus              (BusIface &bus) = 0; 	///< See Song::remove_bus()
  virtual PartIfaceP                    create_part             () = 0; 	///< See Song::create_part()
  virtual void                          remove_part             (PartIface &part) = 0; 	///< See Song::remove_part()
  virtual TrackIfaceP                   create_track            () = 0; 	///< See Song::create_track()
  virtual void                          remove_track            (TrackIface &track) = 0; 	///< See Song::remove_track()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    __visitor_ (*this, "bpm", &SongIface::bpm, &SongIface::bpm);
    __visitor_ (*this, "musical_tuning", &SongIface::musical_tuning, &SongIface::musical_tuning);
    this->SNetIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SongIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SongIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SongIfaceP&);

struct SrvT_SampleFileInfo
{
  /// @cond GeneratedFields
  std::string                   file;
  int64_t                       size;
  int64_t                       mtime;
  std::string                   loader;
  SrvT_StringSeq                waves;
  Error                         error;
  /// @endcond
  inline                        SrvT_SampleFileInfo () { size = 0; mtime = 0; error = Error (0); }
  std::string                   __aida_type_name__ () const	{ return "Bse::SampleFileInfo"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const SrvT_SampleFileInfo &other) const;
  bool                          operator!=  (const SrvT_SampleFileInfo &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (file, "file");
    _visitor_ (size, "size");
    _visitor_ (mtime, "mtime");
    _visitor_ (loader, "loader");
    _visitor_ (waves, "waves");
    _visitor_ (error, "error");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const SrvT_SampleFileInfo&);
void operator>>= (Rapicorn::Aida::ProtoReader&, SrvT_SampleFileInfo&);

class EditableSampleIface;
typedef std::shared_ptr<EditableSampleIface> EditableSampleIfaceP;
typedef std::weak_ptr  <EditableSampleIface> EditableSampleIfaceW;

/** @interface EditableSample
 * See also the corresponding C++ servant class EditableSampleIface. */
/// See also the corresponding IDL class EditableSample.
class EditableSampleIface : public virtual ItemIface
{
protected:
  explicit                               EditableSampleIface ();
  virtual /*Des*/                       ~EditableSampleIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::EditableSample"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const EditableSampleIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, EditableSampleIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, EditableSampleIfaceP&);

class WaveIface;
typedef std::shared_ptr<WaveIface> WaveIfaceP;
typedef std::weak_ptr  <WaveIface> WaveIfaceW;

/** @interface Wave
 * See also the corresponding C++ servant class WaveIface. */
/// See also the corresponding IDL class Wave.
class WaveIface : public virtual SourceIface
{
protected:
  explicit                               WaveIface ();
  virtual /*Des*/                       ~WaveIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::Wave"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SourceIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const WaveIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, WaveIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, WaveIfaceP&);

class WaveRepoIface;
typedef std::shared_ptr<WaveRepoIface> WaveRepoIfaceP;
typedef std::weak_ptr  <WaveRepoIface> WaveRepoIfaceW;

/** @interface WaveRepo
 * See also the corresponding C++ servant class WaveRepoIface. */
/// See also the corresponding IDL class WaveRepo.
class WaveRepoIface : public virtual SuperIface
{
protected:
  explicit                               WaveRepoIface ();
  virtual /*Des*/                       ~WaveRepoIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::WaveRepo"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SuperIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const WaveRepoIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, WaveRepoIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, WaveRepoIfaceP&);

class MidiNotifierIface;
typedef std::shared_ptr<MidiNotifierIface> MidiNotifierIfaceP;
typedef std::weak_ptr  <MidiNotifierIface> MidiNotifierIfaceW;

/** @interface MidiNotifier
 * See also the corresponding C++ servant class MidiNotifierIface. */
/// See also the corresponding IDL class MidiNotifier.
class MidiNotifierIface : public virtual ItemIface
{
protected:
  explicit                               MidiNotifierIface ();
  virtual /*Des*/                       ~MidiNotifierIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::MidiNotifier"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const MidiNotifierIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, MidiNotifierIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, MidiNotifierIfaceP&);

class MidiSynthIface;
typedef std::shared_ptr<MidiSynthIface> MidiSynthIfaceP;
typedef std::weak_ptr  <MidiSynthIface> MidiSynthIfaceW;

/** @interface MidiSynth
 * See also the corresponding C++ servant class MidiSynthIface. */
/// See also the corresponding IDL class MidiSynth.
class MidiSynthIface : public virtual SNetIface
{
protected:
  explicit                               MidiSynthIface ();
  virtual /*Des*/                       ~MidiSynthIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::MidiSynth"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SNetIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const MidiSynthIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, MidiSynthIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, MidiSynthIfaceP&);

class ProjectIface;
typedef std::shared_ptr<ProjectIface> ProjectIfaceP;
typedef std::weak_ptr  <ProjectIface> ProjectIfaceW;

/** @interface Project
 * See also the corresponding C++ servant class ProjectIface. */
/// See also the corresponding IDL class Project.
class ProjectIface : public virtual ContainerIface
{
protected:
  explicit                               ProjectIface ();
  virtual /*Des*/                       ~ProjectIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::Project"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  virtual void                          change_name         (const std::string &name) = 0; 	///< See Project::change_name()
  virtual Error                         play                () = 0; 	///< See Project::play()
  virtual Error                         activate            () = 0; 	///< See Project::activate()
  virtual bool                          can_play            () = 0; 	///< See Project::can_play()
  virtual bool                          is_playing          () = 0; 	///< See Project::is_playing()
  virtual bool                          is_active           () = 0; 	///< See Project::is_active()
  virtual void                          start_playback      () = 0; 	///< See Project::start_playback()
  virtual void                          stop_playback       () = 0; 	///< See Project::stop_playback()
  virtual void                          deactivate          () = 0; 	///< See Project::deactivate()
  virtual void                          stop                () = 0; 	///< See Project::stop()
  virtual void                          auto_deactivate     (int msec_delay) = 0; 	///< See Project::auto_deactivate()
  virtual int                           undo_depth          () = 0; 	///< See Project::undo_depth()
  virtual void                          undo                () = 0; 	///< See Project::undo()
  virtual int                           redo_depth          () = 0; 	///< See Project::redo_depth()
  virtual void                          redo                () = 0; 	///< See Project::redo()
  virtual void                          clear_undo          () = 0; 	///< See Project::clear_undo()
  virtual void                          clean_dirty         () = 0; 	///< See Project::clean_dirty()
  virtual bool                          is_dirty            () = 0; 	///< See Project::is_dirty()
  virtual void                          inject_midi_control (int midi_channel,
                                                             int midi_control,
                                                             double control_value) = 0; 	///< See Project::inject_midi_control()
  virtual Error                         import_midi_file    (const std::string &file_name) = 0; 	///< See Project::import_midi_file()
  virtual Error                         restore_from_file   (const std::string &file_name) = 0; 	///< See Project::restore_from_file()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ContainerIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ProjectIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ProjectIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ProjectIfaceP&);

class PcmWriterIface;
typedef std::shared_ptr<PcmWriterIface> PcmWriterIfaceP;
typedef std::weak_ptr  <PcmWriterIface> PcmWriterIfaceW;

/** @interface PcmWriter
 * See also the corresponding C++ servant class PcmWriterIface. */
/// See also the corresponding IDL class PcmWriter.
class PcmWriterIface : public virtual ItemIface
{
protected:
  explicit                               PcmWriterIface ();
  virtual /*Des*/                       ~PcmWriterIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::PcmWriter"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const PcmWriterIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, PcmWriterIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, PcmWriterIfaceP&);

class ServerIface;
typedef std::shared_ptr<ServerIface> ServerIfaceP;
typedef std::weak_ptr  <ServerIface> ServerIfaceW;

/** @interface Server
 * See also the corresponding C++ servant class ServerIface. */
/// See also the corresponding IDL class Server.
class ServerIface : public virtual ObjectIface
{
protected:
  explicit                               ServerIface ();
  virtual /*Des*/                       ~ServerIface () override = 0;
public:
  virtual Rapicorn::Aida::TypeHashList  __aida_typelist__  () const override;
  virtual std::string                   __aida_type_name__ () const override	{ return "Bse::Server"; }
  virtual std::vector<std::string>      __aida_aux_data__  () const override;
  virtual std::vector<std::string>      __aida_dir__       () const override;
  virtual Rapicorn::Aida::Any           __aida_get__       (const std::string &name) const override;
  virtual bool                          __aida_set__       (const std::string &name, const Rapicorn::Aida::Any &any) override;
  virtual const Rapicorn::Aida::PropertyList& __aida_properties__ ();
  typedef Rapicorn::Aida::Signal<void (const SrvT_UserMessage &umsg)> Signal_user_message;
  Signal_user_message sig_user_message;
  virtual TestObjectIfaceP              get_test_object           () = 0; 	///< See Server::get_test_object()
  virtual ObjectIfaceP                  from_proxy                (int64_t proxyid) = 0; 	///< See Server::from_proxy()
  virtual std::string                   get_mp3_version           () = 0; 	///< See Server::get_mp3_version()
  virtual std::string                   get_vorbis_version        () = 0; 	///< See Server::get_vorbis_version()
  virtual std::string                   get_ladspa_path           () = 0; 	///< See Server::get_ladspa_path()
  virtual std::string                   get_plugin_path           () = 0; 	///< See Server::get_plugin_path()
  virtual std::string                   get_script_path           () = 0; 	///< See Server::get_script_path()
  virtual std::string                   get_instrument_path       () = 0; 	///< See Server::get_instrument_path()
  virtual std::string                   get_sample_path           () = 0; 	///< See Server::get_sample_path()
  virtual std::string                   get_effect_path           () = 0; 	///< See Server::get_effect_path()
  virtual std::string                   get_demo_path             () = 0; 	///< See Server::get_demo_path()
  virtual std::string                   get_custom_instrument_dir () = 0; 	///< See Server::get_custom_instrument_dir()
  virtual std::string                   get_custom_effect_dir     () = 0; 	///< See Server::get_custom_effect_dir()
  virtual std::string                   get_version               () = 0; 	///< See Server::get_version()
  virtual void                          save_preferences          () = 0; 	///< See Server::save_preferences()
  virtual void                          register_ladspa_plugins   () = 0; 	///< See Server::register_ladspa_plugins()
  virtual void                          register_core_plugins     () = 0; 	///< See Server::register_core_plugins()
  virtual void                          register_scripts          () = 0; 	///< See Server::register_scripts()
  virtual bool                          preferences_locked        () = 0; 	///< See Server::preferences_locked()
  virtual int                           n_scripts                 () = 0; 	///< See Server::n_scripts()
  virtual bool                          can_load                  (const std::string &file_name) = 0; 	///< See Server::can_load()
  virtual void                          start_recording           (const std::string &wave_file,
                                                                   double n_seconds) = 0; 	///< See Server::start_recording()
  virtual ProjectIfaceP                 create_project            (const std::string &project_name) = 0; 	///< See Server::create_project()
  virtual void                          destroy_project           (ProjectIface &project) = 0; 	///< See Server::destroy_project()
  virtual SrvT_AuxDataSeq               list_module_types         () = 0; 	///< See Server::list_module_types()
  virtual SrvT_AuxData                  find_module_type          (const std::string &module_type) = 0; 	///< See Server::find_module_type()
  virtual SrvT_Icon                     module_type_icon          (const std::string &module_type) = 0; 	///< See Server::module_type_icon()
  virtual SrvT_SampleFileInfo           sample_file_info          (const std::string &file_name) = 0; 	///< See Server::sample_file_info()
  virtual SrvT_NoteDescription          note_describe             (MusicalTuning musical_tuning,
                                                                   int note,
                                                                   int fine_tune) = 0; 	///< See Server::note_describe()
  virtual SrvT_NoteDescription          note_describe_from_freq   (MusicalTuning musical_tuning,
                                                                   double freq) = 0; 	///< See Server::note_describe_from_freq()
  virtual SrvT_NoteDescription          note_construct            (MusicalTuning musical_tuning,
                                                                   int semitone,
                                                                   int octave,
                                                                   int fine_tune) = 0; 	///< See Server::note_construct()
  virtual SrvT_NoteDescription          note_from_string          (MusicalTuning musical_tuning,
                                                                   const std::string &name) = 0; 	///< See Server::note_from_string()
  virtual int                           note_from_freq            (MusicalTuning musical_tuning,
                                                                   double frequency) = 0; 	///< See Server::note_from_freq()
  virtual double                        note_to_freq              (MusicalTuning musical_tuning,
                                                                   int note,
                                                                   int fine_tune) = 0; 	///< See Server::note_to_freq()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ObjectIface::__accept_accessor__ (__visitor_);
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ServerIfaceP&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ServerIface*&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ServerIfaceP&);
} // Bse

#define BSE_IDL_INTERFACE_LIST \
	  BSE_IDL_INTERFACE_NAME (Bse::TestObject) \
	  BSE_IDL_INTERFACE_NAME (Bse::Object) \
	  BSE_IDL_INTERFACE_NAME (Bse::Item) \
	  BSE_IDL_INTERFACE_NAME (Bse::Part) \
	  BSE_IDL_INTERFACE_NAME (Bse::Source) \
	  BSE_IDL_INTERFACE_NAME (Bse::ContextMerger) \
	  BSE_IDL_INTERFACE_NAME (Bse::Container) \
	  BSE_IDL_INTERFACE_NAME (Bse::Super) \
	  BSE_IDL_INTERFACE_NAME (Bse::SNet) \
	  BSE_IDL_INTERFACE_NAME (Bse::CSynth) \
	  BSE_IDL_INTERFACE_NAME (Bse::SubSynth) \
	  BSE_IDL_INTERFACE_NAME (Bse::Track) \
	  BSE_IDL_INTERFACE_NAME (Bse::Bus) \
	  BSE_IDL_INTERFACE_NAME (Bse::Song) \
	  BSE_IDL_INTERFACE_NAME (Bse::EditableSample) \
	  BSE_IDL_INTERFACE_NAME (Bse::Wave) \
	  BSE_IDL_INTERFACE_NAME (Bse::WaveRepo) \
	  BSE_IDL_INTERFACE_NAME (Bse::MidiNotifier) \
	  BSE_IDL_INTERFACE_NAME (Bse::MidiSynth) \
	  BSE_IDL_INTERFACE_NAME (Bse::Project) \
	  BSE_IDL_INTERFACE_NAME (Bse::PcmWriter) \
	  BSE_IDL_INTERFACE_NAME (Bse::Server)

// C++ Aliases
#ifndef __BSE_IDL_ALIASES__
#define __BSE_IDL_ALIASES__    2
#endif
#if     __BSE_IDL_ALIASES__ == 2
namespace Bse {
typedef SrvT_StringSeq StringSeq;
typedef SrvT_PixelSeq PixelSeq;
typedef SrvT_Icon Icon;
typedef SrvT_AuxData AuxData;
typedef SrvT_AuxDataSeq AuxDataSeq;
typedef SrvT_UserMessage UserMessage;
typedef SrvT_SongTiming SongTiming;
typedef SrvT_NoteDescription NoteDescription;
typedef SrvT_PartNote PartNote;
typedef SrvT_PartNoteSeq PartNoteSeq;
typedef SrvT_PartControl PartControl;
typedef SrvT_PartControlSeq PartControlSeq;
typedef SrvT_PartSeq PartSeq;
typedef SrvT_PartLink PartLink;
typedef SrvT_PartLinkSeq PartLinkSeq;
typedef SrvT_TrackPart TrackPart;
typedef SrvT_TrackPartSeq TrackPartSeq;
typedef SrvT_SampleFileInfo SampleFileInfo;
} // Bse
#endif // __BSE_IDL_ALIASES__

#endif /* __SRVT__BSE_IDL */
