
/*
 * Generated data (by mkcproc.pl)
 */
#line 1 "bsesource.proc"
// Licensed GNU LGPL v2.1 or later: http://www.gnu.org/licenses/lgpl.html
#include <bse/bseplugin.hh>
#include <bse/bseprocedure.hh>
#include <bse/bsesource.hh>
#include <bse/bseundostack.hh>
#include <bse/bseieee754.hh>
#include <bse/bsemidievent.hh>
#include "bsecxxplugin.hh"
#include "bsebuiltin_externs.cc"


#line 14 "bsesource.proc"

/* --- set-input-by-id --- */
static void
set_input_by_id_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 15 "bsesource.proc"
 {
#line 17 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("imodule", "Input Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("input-channel", "Input Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(in_pspecs++) = bse_param_spec_object ("omodule", "Output Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("output-channel", "Output Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", "Error", NULL,
				BSE_TYPE_ERROR_TYPE, Bse::Error::NONE,
				SFI_PARAM_STANDARD);
}
#line 29 "bsesource.proc"
 }
static Bse::Error
#line 29 "bsesource.proc"
set_input_by_id_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 32 "bsesource.proc"
{
#line 33 "bsesource.proc"
  
  BseSource *isource = (BseSource*) bse_value_get_object (in_values++);
  guint ichannel     = sfi_value_get_int (in_values++);
  BseSource *osource = (BseSource*) bse_value_get_object (in_values++);
  guint ochannel     = sfi_value_get_int (in_values++);
  Bse::Error error;

#line 40 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (isource) || !BSE_IS_SOURCE (osource) ||
      BSE_ITEM (isource)->parent != BSE_ITEM (osource)->parent)
    return Bse::Error::PROC_PARAM_INVAL;

#line 45 "bsesource.proc"
  
  error = bse_source_set_input (isource, ichannel, osource, ochannel);
  if (error == Bse::Error::NONE)
    bse_item_push_undo_proc (isource, "unset-input-by-id", ichannel, osource, ochannel);

#line 50 "bsesource.proc"
  
  g_value_set_enum (out_values++, int (error));

  return Bse::Error::NONE;
}

/* --- set-input --- */
static void
set_input_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 56 "bsesource.proc"
 {
#line 58 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("imodule", "Input Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_string ("input-channel", "Input Channel", NULL,
			    NULL, SFI_PARAM_STANDARD);
  *(in_pspecs++) = bse_param_spec_object ("omodule", "Output Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_string ("output-channel", "Output Channel", NULL,
			    NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", "Error", NULL,
				BSE_TYPE_ERROR_TYPE, Bse::Error::NONE,
				SFI_PARAM_STANDARD);
}
#line 70 "bsesource.proc"
 }
static Bse::Error
#line 70 "bsesource.proc"
set_input_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 73 "bsesource.proc"
{
#line 74 "bsesource.proc"
  
  BseSource *isource = (BseSource*) bse_value_get_object (in_values++);
  const char *ichannel_ident = sfi_value_get_string (in_values++);
  BseSource *osource = (BseSource*) bse_value_get_object (in_values++);
  const char *ochannel_ident = sfi_value_get_string (in_values++);
  guint ichannel, ochannel;
  Bse::Error error;

#line 82 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (isource) || !BSE_IS_SOURCE (osource) ||
      BSE_ITEM (isource)->parent != BSE_ITEM (osource)->parent ||
      !ichannel_ident || !ochannel_ident)
    return Bse::Error::PROC_PARAM_INVAL;

#line 88 "bsesource.proc"
  
  ichannel = bse_source_find_ichannel (isource, ichannel_ident);
  ochannel = bse_source_find_ochannel (osource, ochannel_ident);
  error = bse_source_set_input (isource, ichannel, osource, ochannel);
  if (error == Bse::Error::NONE)
    bse_item_push_undo_proc (isource, "unset-input-by-id", ichannel, osource, ochannel);

#line 95 "bsesource.proc"
  
  g_value_set_enum (out_values++, int (error));

  return Bse::Error::NONE;
}

/* --- unset-input-by-id --- */
static void
unset_input_by_id_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 101 "bsesource.proc"
 {
#line 103 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("input-channel", "Input Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(in_pspecs++) = bse_param_spec_object ("omodule", "Output Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("output-channel", "Output Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", "Error", NULL,
				BSE_TYPE_ERROR_TYPE, Bse::Error::NONE,
				SFI_PARAM_STANDARD);
}
#line 115 "bsesource.proc"
 }
static Bse::Error
#line 115 "bsesource.proc"
unset_input_by_id_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 118 "bsesource.proc"
{
#line 119 "bsesource.proc"
  
  BseSource *isource = (BseSource*) bse_value_get_object (in_values++);
  guint ichannel     = sfi_value_get_int (in_values++);
  BseSource *osource = (BseSource*) bse_value_get_object (in_values++);
  guint ochannel     = sfi_value_get_int (in_values++);
  Bse::Error error = Bse::Error::NONE;

#line 126 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (isource) || !BSE_IS_SOURCE (osource))
    return Bse::Error::PROC_PARAM_INVAL;

#line 130 "bsesource.proc"
  
  error = bse_source_check_input (isource, ichannel, osource, ochannel);
  if (error == Bse::Error::NONE)
    {
      BseUndoStack *ustack = bse_item_undo_open (isource, "unset-input-by-id");
      bse_source_input_backup_to_undo (isource, ichannel, osource, ochannel);
      bse_item_push_redo_proc (isource, "unset-input-by-id", ichannel, osource, ochannel);
      bse_item_undo_close (ustack);
      error = bse_source_unset_input (isource, ichannel, osource, ochannel);
    }

#line 141 "bsesource.proc"
  
  g_value_set_enum (out_values++, int (error));

  return Bse::Error::NONE;
}

/* --- unset-input --- */
static void
unset_input_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 147 "bsesource.proc"
 {
#line 149 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("input-channel", "Input Channel", NULL,
			    NULL, SFI_PARAM_STANDARD);
  *(in_pspecs++) = bse_param_spec_object ("omodule", "Output Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("output-channel", "Output Channel", NULL,
			    NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", "Error", NULL,
				BSE_TYPE_ERROR_TYPE, Bse::Error::NONE,
				SFI_PARAM_STANDARD);
}
#line 161 "bsesource.proc"
 }
static Bse::Error
#line 161 "bsesource.proc"
unset_input_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 164 "bsesource.proc"
{
#line 165 "bsesource.proc"
  
  BseSource *isource = (BseSource*) bse_value_get_object (in_values++);
  const char *ichannel_ident = sfi_value_get_string (in_values++);
  BseSource *osource = (BseSource*) bse_value_get_object (in_values++);
  const char *ochannel_ident = sfi_value_get_string (in_values++);
  guint ichannel, ochannel;
  Bse::Error error = Bse::Error::NONE;

#line 173 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (isource) || !BSE_IS_SOURCE (osource) ||
      !ichannel_ident || !ochannel_ident)
    return Bse::Error::PROC_PARAM_INVAL;

#line 178 "bsesource.proc"
  
  ichannel = bse_source_find_ichannel (isource, ichannel_ident);
  ochannel = bse_source_find_ochannel (osource, ochannel_ident);
  error = bse_source_check_input (isource, ichannel, osource, ochannel);
  if (error == Bse::Error::NONE)
    {
      BseUndoStack *ustack = bse_item_undo_open (isource, "unset-input-by-id");
      bse_source_input_backup_to_undo (isource, ichannel, osource, ochannel);
      bse_item_push_redo_proc (isource, "unset-input-by-id", ichannel, osource, ochannel);
      bse_item_undo_close (ustack);
      error = bse_source_unset_input (isource, ichannel, osource, ochannel);
    }

#line 191 "bsesource.proc"
  
  g_value_set_enum (out_values++, int (error));

  return Bse::Error::NONE;
}

/* --- clear-inputs --- */
static void
clear_inputs_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 197 "bsesource.proc"
 {
#line 199 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
}
#line 202 "bsesource.proc"
 }
static Bse::Error
#line 202 "bsesource.proc"
clear_inputs_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 205 "bsesource.proc"
{
#line 206 "bsesource.proc"
  
  BseSource *isource = (BseSource*) bse_value_get_object (in_values++);
  BseUndoStack *ustack;

#line 210 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (isource))
    return Bse::Error::PROC_PARAM_INVAL;

#line 214 "bsesource.proc"
  
  ustack = bse_item_undo_open (isource, "clear-inputs %s", bse_object_debug_name (isource));
  bse_source_backup_ichannels_to_undo (isource);
  bse_item_push_redo_proc (isource, "clear-inputs");
  bse_item_undo_close (ustack);
  bse_source_clear_ichannels (isource);

  return Bse::Error::NONE;
}

/* --- clear-outputs --- */
static void
clear_outputs_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 224 "bsesource.proc"
 {
#line 226 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
}
#line 229 "bsesource.proc"
 }
static Bse::Error
#line 229 "bsesource.proc"
clear_outputs_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 232 "bsesource.proc"
{
#line 233 "bsesource.proc"
  
  BseSource *isource = (BseSource*) bse_value_get_object (in_values++);
  BseUndoStack *ustack;

#line 237 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (isource))
    return Bse::Error::PROC_PARAM_INVAL;

#line 241 "bsesource.proc"
  
  ustack = bse_item_undo_open (isource, "clear-outputs %s", bse_object_debug_name (isource));
  bse_source_backup_ochannels_to_undo (isource);
  bse_item_push_redo_proc (isource, "clear-outputs");
  bse_item_undo_close (ustack);
  bse_source_clear_ochannels (isource);

  return Bse::Error::NONE;
}

/* --- has-output --- */
static void
has_output_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 251 "bsesource.proc"
 {
#line 253 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", NULL, NULL, BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_int ("ochannel", NULL, NULL, 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_bool ("has_outputs", NULL, NULL, FALSE, SFI_PARAM_STANDARD);
}
#line 257 "bsesource.proc"
 }
static Bse::Error
#line 257 "bsesource.proc"
has_output_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 260 "bsesource.proc"
{
#line 261 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  guint ochannel    = sfi_value_get_int (in_values++);

#line 265 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 269 "bsesource.proc"
  
  sfi_value_set_bool (out_values++, bse_source_has_output (source, ochannel));

  return Bse::Error::NONE;
}

/* --- has-outputs --- */
static void
has_outputs_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 275 "bsesource.proc"
 {
#line 277 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_bool ("has_outputs", "Has Outputs", NULL,
			  FALSE, SFI_PARAM_STANDARD);
}
#line 282 "bsesource.proc"
 }
static Bse::Error
#line 282 "bsesource.proc"
has_outputs_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 285 "bsesource.proc"
{
#line 286 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);

#line 289 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 293 "bsesource.proc"
  
  sfi_value_set_bool (out_values++, source->outputs != NULL);

  return Bse::Error::NONE;
}

/* --- n-ichannels --- */
static void
n_ichannels_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 299 "bsesource.proc"
 {
#line 301 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_int ("n_channels", "Number of Channels", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
}
#line 306 "bsesource.proc"
 }
static Bse::Error
#line 306 "bsesource.proc"
n_ichannels_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 309 "bsesource.proc"
{
#line 310 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);

#line 313 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 317 "bsesource.proc"
  
  sfi_value_set_int (out_values++, BSE_SOURCE_N_ICHANNELS (source));

  return Bse::Error::NONE;
}

/* --- ichannel-label --- */
static void
ichannel_label_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 323 "bsesource.proc"
 {
#line 325 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("input-channel", "Input Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_string ("channel_label", "Channel Name", NULL,
			    NULL, SFI_PARAM_STANDARD);
}
#line 332 "bsesource.proc"
 }
static Bse::Error
#line 332 "bsesource.proc"
ichannel_label_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 335 "bsesource.proc"
{
#line 336 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  guint ichannel    = sfi_value_get_int (in_values++);

#line 340 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || ichannel >= BSE_SOURCE_N_ICHANNELS (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 344 "bsesource.proc"
  
  sfi_value_set_string (out_values++, BSE_SOURCE_ICHANNEL_LABEL (source, ichannel));

  return Bse::Error::NONE;
}

/* --- ichannel-ident --- */
static void
ichannel_ident_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 350 "bsesource.proc"
 {
#line 352 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("input-channel", "Input Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_string ("channel_ident", "Channel Name", NULL,
			    NULL, SFI_PARAM_STANDARD);
}
#line 359 "bsesource.proc"
 }
static Bse::Error
#line 359 "bsesource.proc"
ichannel_ident_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 362 "bsesource.proc"
{
#line 363 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  guint ichannel    = sfi_value_get_int (in_values++);

#line 367 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || ichannel >= BSE_SOURCE_N_ICHANNELS (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 371 "bsesource.proc"
  
  sfi_value_set_string (out_values++, BSE_SOURCE_ICHANNEL_IDENT (source, ichannel));

  return Bse::Error::NONE;
}

/* --- ichannel-blurb --- */
static void
ichannel_blurb_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 377 "bsesource.proc"
 {
#line 379 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("input-channel", "Input Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_string ("channel_blurb", "Channel Blurb", NULL,
			    NULL, SFI_PARAM_STANDARD);
}
#line 386 "bsesource.proc"
 }
static Bse::Error
#line 386 "bsesource.proc"
ichannel_blurb_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 389 "bsesource.proc"
{
#line 390 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  guint ichannel    = sfi_value_get_int (in_values++);

#line 394 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || ichannel >= BSE_SOURCE_N_ICHANNELS (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 398 "bsesource.proc"
  
  sfi_value_set_string (out_values++, BSE_SOURCE_ICHANNEL_BLURB (source, ichannel));

  return Bse::Error::NONE;
}

/* --- is-joint-ichannel-by-id --- */
static void
is_joint_ichannel_by_id_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 404 "bsesource.proc"
 {
#line 406 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("input-channel", "Input Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_bool ("is_jchannel", "Is Joint Channel", NULL,
			  FALSE, SFI_PARAM_STANDARD);
}
#line 413 "bsesource.proc"
 }
static Bse::Error
#line 413 "bsesource.proc"
is_joint_ichannel_by_id_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 416 "bsesource.proc"
{
#line 417 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  guint ichannel    = sfi_value_get_int (in_values++);

#line 421 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || ichannel >= BSE_SOURCE_N_ICHANNELS (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 425 "bsesource.proc"
  
  sfi_value_set_bool (out_values++, BSE_SOURCE_IS_JOINT_ICHANNEL (source, ichannel));

  return Bse::Error::NONE;
}

/* --- is-joint-ichannel --- */
static void
is_joint_ichannel_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 431 "bsesource.proc"
 {
#line 433 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("input-channel", "Input Channel", NULL,
			    NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_bool ("is_jchannel", "Is Joint Channel", NULL,
			  FALSE, SFI_PARAM_STANDARD);
}
#line 440 "bsesource.proc"
 }
static Bse::Error
#line 440 "bsesource.proc"
is_joint_ichannel_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 443 "bsesource.proc"
{
#line 444 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  const char *ichannel   = sfi_value_get_string (in_values++);
  guint id;

#line 449 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || !ichannel)
    return Bse::Error::PROC_PARAM_INVAL;

#line 453 "bsesource.proc"
  
  id = bse_source_find_ichannel (source, ichannel);
  sfi_value_set_bool (out_values++,
		      id < BSE_SOURCE_N_ICHANNELS (source) ? BSE_SOURCE_IS_JOINT_ICHANNEL (source, id) : FALSE);

  return Bse::Error::NONE;
}

/* --- ichannel-get-n-joints --- */
static void
ichannel_get_n_joints_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 461 "bsesource.proc"
 {
#line 463 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("input-channel", "Input Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_int ("n_joints", "Number of Connections", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
}
#line 470 "bsesource.proc"
 }
static Bse::Error
#line 470 "bsesource.proc"
ichannel_get_n_joints_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 473 "bsesource.proc"
{
#line 474 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  guint ichannel    = sfi_value_get_int (in_values++);
  BseSourceInput *input;

#line 479 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || ichannel >= BSE_SOURCE_N_ICHANNELS (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 483 "bsesource.proc"
  
  input = BSE_SOURCE_INPUT (source, ichannel);
  if (BSE_SOURCE_IS_JOINT_ICHANNEL (source, ichannel))
    sfi_value_set_int (out_values++, input->jdata.n_joints);
  else
    sfi_value_set_int (out_values++, input->idata.osource ? 1 : 0);

  return Bse::Error::NONE;
}

/* --- ichannel-get-ochannel --- */
static void
ichannel_get_ochannel_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 493 "bsesource.proc"
 {
#line 495 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("input-channel", "Input Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("input-joint", "Input Joint", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_int ("ochannel", "Output Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
}
#line 504 "bsesource.proc"
 }
static Bse::Error
#line 504 "bsesource.proc"
ichannel_get_ochannel_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 507 "bsesource.proc"
{
#line 508 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  guint ichannel    = sfi_value_get_int (in_values++);
  guint joint       = sfi_value_get_int (in_values++);
  BseSourceInput *input;

#line 514 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || ichannel >= BSE_SOURCE_N_ICHANNELS (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 518 "bsesource.proc"
  
  input = BSE_SOURCE_INPUT (source, ichannel);
  if (BSE_SOURCE_IS_JOINT_ICHANNEL (source, ichannel) && joint < input->jdata.n_joints)
    sfi_value_set_int (out_values++, input->jdata.joints[joint].ochannel);
  else if (joint < 1)
    sfi_value_set_int (out_values++, input->idata.ochannel);
  else
    sfi_value_set_int (out_values++, G_MAXINT);

  return Bse::Error::NONE;
}

/* --- n-ochannels --- */
static void
n_ochannels_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 530 "bsesource.proc"
 {
#line 532 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_int ("n_channels", "Number of Channels", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
}
#line 537 "bsesource.proc"
 }
static Bse::Error
#line 537 "bsesource.proc"
n_ochannels_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 540 "bsesource.proc"
{
#line 541 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);

#line 544 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 548 "bsesource.proc"
  
  sfi_value_set_int (out_values++, BSE_SOURCE_N_OCHANNELS (source));

  return Bse::Error::NONE;
}

/* --- ochannel-label --- */
static void
ochannel_label_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 554 "bsesource.proc"
 {
#line 556 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("output-channel", "Input Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_string ("channel_label", "Channel Name", NULL,
			    NULL, SFI_PARAM_STANDARD);
}
#line 563 "bsesource.proc"
 }
static Bse::Error
#line 563 "bsesource.proc"
ochannel_label_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 566 "bsesource.proc"
{
#line 567 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  guint ochannel    = sfi_value_get_int (in_values++);

#line 571 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || ochannel >= BSE_SOURCE_N_OCHANNELS (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 575 "bsesource.proc"
  
  sfi_value_set_string (out_values++, BSE_SOURCE_OCHANNEL_LABEL (source, ochannel));

  return Bse::Error::NONE;
}

/* --- ochannel-ident --- */
static void
ochannel_ident_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 581 "bsesource.proc"
 {
#line 583 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("output-channel", "Input Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_string ("channel_ident", "Channel Name", NULL,
			    NULL, SFI_PARAM_STANDARD);
}
#line 590 "bsesource.proc"
 }
static Bse::Error
#line 590 "bsesource.proc"
ochannel_ident_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 593 "bsesource.proc"
{
#line 594 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  guint ochannel    = sfi_value_get_int (in_values++);

#line 598 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || ochannel >= BSE_SOURCE_N_OCHANNELS (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 602 "bsesource.proc"
  
  sfi_value_set_string (out_values++, BSE_SOURCE_OCHANNEL_IDENT (source, ochannel));

  return Bse::Error::NONE;
}

/* --- ochannel-blurb --- */
static void
ochannel_blurb_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 608 "bsesource.proc"
 {
#line 610 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("output-channel", "Input Channel", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_string ("channel_blurb", "Channel Blurb", NULL,
			    NULL, SFI_PARAM_STANDARD);
}
#line 617 "bsesource.proc"
 }
static Bse::Error
#line 617 "bsesource.proc"
ochannel_blurb_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 620 "bsesource.proc"
{
#line 621 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  guint ochannel    = sfi_value_get_int (in_values++);

#line 625 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || ochannel >= BSE_SOURCE_N_OCHANNELS (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 629 "bsesource.proc"
  
  sfi_value_set_string (out_values++, BSE_SOURCE_OCHANNEL_BLURB (source, ochannel));

  return Bse::Error::NONE;
}

/* --- set-pos --- */
static void
set_pos_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 635 "bsesource.proc"
 {
#line 642 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("module", "Module", NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_real ("x-pos", "X Position", NULL,
                          0, -SFI_MAXREAL, SFI_MAXREAL, 1, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_real ("y-pos", "Y Position", NULL,
                          0, -SFI_MAXREAL, SFI_MAXREAL, 1, SFI_PARAM_STANDARD);
}
#line 649 "bsesource.proc"
 }
static Bse::Error
#line 649 "bsesource.proc"
set_pos_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 652 "bsesource.proc"
{
#line 653 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  SfiReal xpos      = sfi_value_get_real (in_values++);
  SfiReal ypos      = sfi_value_get_real (in_values++);
  SfiReal epsilon = 1e-5;

#line 659 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || BSE_DOUBLE_IS_NANINF (xpos) || BSE_DOUBLE_IS_NANINF (ypos))
    return Bse::Error::PROC_PARAM_INVAL;

#line 663 "bsesource.proc"
  
  if (fabs (xpos - source->pos_x) > epsilon ||
      fabs (ypos - source->pos_y) > epsilon)
    {
      BseUndoStack *ustack = bse_item_undo_open (source, "set-xy-pos");
      bse_item_set (source,
                    "pos_x", xpos,
                    "pos_y", ypos,
                    NULL);
      bse_item_undo_close (ustack);
    }

  return Bse::Error::NONE;
}

/* --- set-automation --- */
static void
set_automation_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 678 "bsesource.proc"
 {
#line 680 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("source", NULL, NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("property_name", NULL, "Item property name",
                            NULL, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_int ("midi_channel", _("MIDI Channel"), _("The MIDI Channel from which automation events should be received, 0 designates the default MIDI channel"),
                         0, 0, BSE_MIDI_MAX_CHANNELS, 1, SFI_PARAM_STANDARD ":scale:unprepared");
  *(in_pspecs++)    = bse_param_spec_genum ("control_type", _("Control Type"), _("The type of control events used for automation"),
                                BSE_TYPE_MIDI_CONTROL_TYPE, BSE_MIDI_CONTROL_CONTINUOUS_16, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", "Error", NULL, BSE_TYPE_ERROR_TYPE, Bse::Error::NONE, SFI_PARAM_STANDARD);
}
#line 690 "bsesource.proc"
 }
static Bse::Error
#line 690 "bsesource.proc"
set_automation_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 693 "bsesource.proc"
{
#line 694 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  const char *property = sfi_value_get_string (in_values++);
  guint      midi_channel = sfi_value_get_int (in_values++);
  Bse::MidiSignal control_type = (Bse::MidiSignal) g_value_get_enum (in_values++);
  Bse::Error error = Bse::Error::NONE;

#line 701 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || !property)
    return Bse::Error::PROC_PARAM_INVAL;

#line 705 "bsesource.proc"
  
  guint old_midi_channel = 0;
  Bse::MidiSignal old_control_type = Bse::MidiSignal (0);
  bse_source_get_automation_property (source, property, &old_midi_channel, &old_control_type);
  if (old_midi_channel != midi_channel || old_control_type != control_type)
    {
      error = bse_source_set_automation_property (source, property, midi_channel, control_type);
      if (error == Bse::Error::NONE)
        bse_item_push_undo_proc (source, "set-automation", property, old_midi_channel, old_control_type);
    }

#line 716 "bsesource.proc"
  
  g_value_set_enum (out_values++, int (error));

  return Bse::Error::NONE;
}

/* --- get-automation-channel --- */
static void
get_automation_channel_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 722 "bsesource.proc"
 {
#line 724 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("source", NULL, NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("property_name", NULL, "Item property name",
                            NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_int ("midi_channel", NULL, NULL, 0, 0, BSE_MIDI_MAX_CHANNELS, 1, SFI_PARAM_STANDARD ":scale:unprepared");
}
#line 730 "bsesource.proc"
 }
static Bse::Error
#line 730 "bsesource.proc"
get_automation_channel_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 733 "bsesource.proc"
{
#line 734 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  const char *property = sfi_value_get_string (in_values++);

#line 738 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || !property)
    return Bse::Error::PROC_PARAM_INVAL;

#line 742 "bsesource.proc"
  
  guint midi_channel = 0;
  bse_source_get_automation_property (source, property, &midi_channel, NULL);
#line 745 "bsesource.proc"
  
  g_value_set_int (out_values++, midi_channel);

  return Bse::Error::NONE;
}

/* --- get-automation-control --- */
static void
get_automation_control_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 751 "bsesource.proc"
 {
#line 753 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("source", NULL, NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("property_name", NULL, "Item property name",
                            NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("control_type", NULL, NULL, BSE_TYPE_MIDI_CONTROL_TYPE, BSE_MIDI_CONTROL_CONTINUOUS_16, SFI_PARAM_STANDARD);
}
#line 759 "bsesource.proc"
 }
static Bse::Error
#line 759 "bsesource.proc"
get_automation_control_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 762 "bsesource.proc"
{
#line 763 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);
  const char *property = sfi_value_get_string (in_values++);

#line 767 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source) || !property)
    return Bse::Error::PROC_PARAM_INVAL;

#line 771 "bsesource.proc"
  
  Bse::MidiSignal control_type = Bse::MidiSignal (0);
  bse_source_get_automation_property (source, property, NULL, &control_type);
#line 774 "bsesource.proc"
  
  g_value_set_enum (out_values++, int (control_type));

  return Bse::Error::NONE;
}

/* --- is-prepared --- */
static void
is_prepared_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 780 "bsesource.proc"
 {
#line 782 "bsesource.proc"
  *(in_pspecs++) = bse_param_spec_object ("source", NULL, NULL,
				 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_bool ("is_prepared", NULL, NULL, FALSE, SFI_PARAM_STANDARD);
#line 785 "bsesource.proc"
}  }
static Bse::Error
#line 785 "bsesource.proc"
is_prepared_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 788 "bsesource.proc"
{
#line 789 "bsesource.proc"
  
  BseSource *source = (BseSource*) bse_value_get_object (in_values++);

#line 792 "bsesource.proc"
  
  if (!BSE_IS_SOURCE (source))
    return Bse::Error::PROC_PARAM_INVAL;

#line 796 "bsesource.proc"
  
  sfi_value_set_bool (out_values++, BSE_SOURCE_PREPARED (source));

  return Bse::Error::NONE;
}

/* --- Export to BSE --- */
static void
__enode_set_input_by_id__fill_strings (BseExportStrings *es)
{
  es->blurb = "Connect a module input to another module's output.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 16;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_set_input_by_id = {
  { NULL, BSE_EXPORT_NODE_PROC,
    "BseSource+set-input-by-id", 
    NULL,
    "/Methods/BseSource/General/Set Input By Id",
    NULL,
    __enode_set_input_by_id__fill_strings,
  },
  0, set_input_by_id_setup, set_input_by_id_exec, 
};
static void
__enode_set_input__fill_strings (BseExportStrings *es)
{
  es->blurb = "Connect a module input to another module's output.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 57;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_set_input = {
  { (BseExportNode*) &__enode_set_input_by_id, BSE_EXPORT_NODE_PROC,
    "BseSource+set-input", 
    NULL,
    "/Methods/BseSource/General/Set Input",
    NULL,
    __enode_set_input__fill_strings,
  },
  0, set_input_setup, set_input_exec, 
};
static void
__enode_unset_input_by_id__fill_strings (BseExportStrings *es)
{
  es->blurb = "Disconnect a module input.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 102;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_unset_input_by_id = {
  { (BseExportNode*) &__enode_set_input, BSE_EXPORT_NODE_PROC,
    "BseSource+unset-input-by-id", 
    NULL,
    "/Methods/BseSource/General/Unset Input By Id",
    NULL,
    __enode_unset_input_by_id__fill_strings,
  },
  0, unset_input_by_id_setup, unset_input_by_id_exec, 
};
static void
__enode_unset_input__fill_strings (BseExportStrings *es)
{
  es->blurb = "Disconnect a module input.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 148;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_unset_input = {
  { (BseExportNode*) &__enode_unset_input_by_id, BSE_EXPORT_NODE_PROC,
    "BseSource+unset-input", 
    NULL,
    "/Methods/BseSource/General/Unset Input",
    NULL,
    __enode_unset_input__fill_strings,
  },
  0, unset_input_setup, unset_input_exec, 
};
static void
__enode_clear_inputs__fill_strings (BseExportStrings *es)
{
  es->blurb = "Disconnect all module inputs.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 198;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_clear_inputs = {
  { (BseExportNode*) &__enode_unset_input, BSE_EXPORT_NODE_PROC,
    "BseSource+clear-inputs", 
    NULL,
    "/Methods/BseSource/General/Clear Inputs",
    NULL,
    __enode_clear_inputs__fill_strings,
  },
  0, clear_inputs_setup, clear_inputs_exec, 
};
static void
__enode_clear_outputs__fill_strings (BseExportStrings *es)
{
  es->blurb = "Disconnect all module outputs.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 225;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_clear_outputs = {
  { (BseExportNode*) &__enode_clear_inputs, BSE_EXPORT_NODE_PROC,
    "BseSource+clear-outputs", 
    NULL,
    "/Methods/BseSource/General/Clear Outputs",
    NULL,
    __enode_clear_outputs__fill_strings,
  },
  0, clear_outputs_setup, clear_outputs_exec, 
};
static void
__enode_has_output__fill_strings (BseExportStrings *es)
{
  es->blurb = "Check whether a module's output channel is connected.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 252;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_has_output = {
  { (BseExportNode*) &__enode_clear_outputs, BSE_EXPORT_NODE_PROC,
    "BseSource+has-output", 
    NULL,
    "/Methods/BseSource/General/Has Output",
    NULL,
    __enode_has_output__fill_strings,
  },
  0, has_output_setup, has_output_exec, 
};
static void
__enode_has_outputs__fill_strings (BseExportStrings *es)
{
  es->blurb = "Check whether a module has output channel connections.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 276;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_has_outputs = {
  { (BseExportNode*) &__enode_has_output, BSE_EXPORT_NODE_PROC,
    "BseSource+has-outputs", 
    NULL,
    "/Methods/BseSource/General/Has Outputs",
    NULL,
    __enode_has_outputs__fill_strings,
  },
  0, has_outputs_setup, has_outputs_exec, 
};
static void
__enode_n_ichannels__fill_strings (BseExportStrings *es)
{
  es->blurb = "Get the number of input channels of a module.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 300;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_n_ichannels = {
  { (BseExportNode*) &__enode_has_outputs, BSE_EXPORT_NODE_PROC,
    "BseSource+n-ichannels", 
    NULL,
    "/Methods/BseSource/General/N Ichannels",
    NULL,
    __enode_n_ichannels__fill_strings,
  },
  0, n_ichannels_setup, n_ichannels_exec, 
};
static void
__enode_ichannel_label__fill_strings (BseExportStrings *es)
{
  es->blurb = "Get input channel name.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 324;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_ichannel_label = {
  { (BseExportNode*) &__enode_n_ichannels, BSE_EXPORT_NODE_PROC,
    "BseSource+ichannel-label", 
    NULL,
    "/Methods/BseSource/General/Ichannel Label",
    NULL,
    __enode_ichannel_label__fill_strings,
  },
  0, ichannel_label_setup, ichannel_label_exec, 
};
static void
__enode_ichannel_ident__fill_strings (BseExportStrings *es)
{
  es->blurb = "Get canonical input channel name.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 351;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_ichannel_ident = {
  { (BseExportNode*) &__enode_ichannel_label, BSE_EXPORT_NODE_PROC,
    "BseSource+ichannel-ident", 
    NULL,
    "/Methods/BseSource/General/Ichannel Ident",
    NULL,
    __enode_ichannel_ident__fill_strings,
  },
  0, ichannel_ident_setup, ichannel_ident_exec, 
};
static void
__enode_ichannel_blurb__fill_strings (BseExportStrings *es)
{
  es->blurb = "Get input channel description.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 378;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_ichannel_blurb = {
  { (BseExportNode*) &__enode_ichannel_ident, BSE_EXPORT_NODE_PROC,
    "BseSource+ichannel-blurb", 
    NULL,
    "/Methods/BseSource/General/Ichannel Blurb",
    NULL,
    __enode_ichannel_blurb__fill_strings,
  },
  0, ichannel_blurb_setup, ichannel_blurb_exec, 
};
static void
__enode_is_joint_ichannel_by_id__fill_strings (BseExportStrings *es)
{
  es->blurb = "Check if an input channel is a joint (multi-connect) channel.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 405;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_is_joint_ichannel_by_id = {
  { (BseExportNode*) &__enode_ichannel_blurb, BSE_EXPORT_NODE_PROC,
    "BseSource+is-joint-ichannel-by-id", 
    NULL,
    "/Methods/BseSource/General/Is Joint Ichannel By Id",
    NULL,
    __enode_is_joint_ichannel_by_id__fill_strings,
  },
  0, is_joint_ichannel_by_id_setup, is_joint_ichannel_by_id_exec, 
};
static void
__enode_is_joint_ichannel__fill_strings (BseExportStrings *es)
{
  es->blurb = "Check if an input channel is a joint (multi-connect) channel.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 432;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_is_joint_ichannel = {
  { (BseExportNode*) &__enode_is_joint_ichannel_by_id, BSE_EXPORT_NODE_PROC,
    "BseSource+is-joint-ichannel", 
    NULL,
    "/Methods/BseSource/General/Is Joint Ichannel",
    NULL,
    __enode_is_joint_ichannel__fill_strings,
  },
  0, is_joint_ichannel_setup, is_joint_ichannel_exec, 
};
static void
__enode_ichannel_get_n_joints__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve the number of inputs connected to an input channel.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 462;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_ichannel_get_n_joints = {
  { (BseExportNode*) &__enode_is_joint_ichannel, BSE_EXPORT_NODE_PROC,
    "BseSource+ichannel-get-n-joints", 
    NULL,
    "/Methods/BseSource/General/Ichannel Get N Joints",
    NULL,
    __enode_ichannel_get_n_joints__fill_strings,
  },
  0, ichannel_get_n_joints_setup, ichannel_get_n_joints_exec, 
};
static void
__enode_ichannel_get_ochannel__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve output channel of the module connected to a specific joint of an input channel.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 494;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_ichannel_get_ochannel = {
  { (BseExportNode*) &__enode_ichannel_get_n_joints, BSE_EXPORT_NODE_PROC,
    "BseSource+ichannel-get-ochannel", 
    NULL,
    "/Methods/BseSource/General/Ichannel Get Ochannel",
    NULL,
    __enode_ichannel_get_ochannel__fill_strings,
  },
  0, ichannel_get_ochannel_setup, ichannel_get_ochannel_exec, 
};
static void
__enode_n_ochannels__fill_strings (BseExportStrings *es)
{
  es->blurb = "Get the number of output channels of a module.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 531;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_n_ochannels = {
  { (BseExportNode*) &__enode_ichannel_get_ochannel, BSE_EXPORT_NODE_PROC,
    "BseSource+n-ochannels", 
    NULL,
    "/Methods/BseSource/General/N Ochannels",
    NULL,
    __enode_n_ochannels__fill_strings,
  },
  0, n_ochannels_setup, n_ochannels_exec, 
};
static void
__enode_ochannel_label__fill_strings (BseExportStrings *es)
{
  es->blurb = "Get output channel name.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 555;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_ochannel_label = {
  { (BseExportNode*) &__enode_n_ochannels, BSE_EXPORT_NODE_PROC,
    "BseSource+ochannel-label", 
    NULL,
    "/Methods/BseSource/General/Ochannel Label",
    NULL,
    __enode_ochannel_label__fill_strings,
  },
  0, ochannel_label_setup, ochannel_label_exec, 
};
static void
__enode_ochannel_ident__fill_strings (BseExportStrings *es)
{
  es->blurb = "Get canonical output channel name.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 582;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_ochannel_ident = {
  { (BseExportNode*) &__enode_ochannel_label, BSE_EXPORT_NODE_PROC,
    "BseSource+ochannel-ident", 
    NULL,
    "/Methods/BseSource/General/Ochannel Ident",
    NULL,
    __enode_ochannel_ident__fill_strings,
  },
  0, ochannel_ident_setup, ochannel_ident_exec, 
};
static void
__enode_ochannel_blurb__fill_strings (BseExportStrings *es)
{
  es->blurb = "Get output channel description.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 609;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_ochannel_blurb = {
  { (BseExportNode*) &__enode_ochannel_ident, BSE_EXPORT_NODE_PROC,
    "BseSource+ochannel-blurb", 
    NULL,
    "/Methods/BseSource/General/Ochannel Blurb",
    NULL,
    __enode_ochannel_blurb__fill_strings,
  },
  0, ochannel_blurb_setup, ochannel_blurb_exec, 
};
static void
__enode_set_pos__fill_strings (BseExportStrings *es)
{
  es->blurb = "Set the x and y position of a module. In contrast to setting the position "
          "through ordinary object property setters, this function will not update "
          "the module position if the passed in arguments are sufficiently equal to "
          "the values already set on the object. As such, it does not record an extra "
          "undo step for setting properties to values they already have and if necessary "
          "turns setting of x and y positions into an atomic undo operation.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 636;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_set_pos = {
  { (BseExportNode*) &__enode_ochannel_blurb, BSE_EXPORT_NODE_PROC,
    "BseSource+set-pos", 
    NULL,
    "/Methods/BseSource/General/Set Pos",
    NULL,
    __enode_set_pos__fill_strings,
  },
  0, set_pos_setup, set_pos_exec, 
};
static void
__enode_set_automation__fill_strings (BseExportStrings *es)
{
  es->blurb = "Setup automation parameters for a property.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 679;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_set_automation = {
  { (BseExportNode*) &__enode_set_pos, BSE_EXPORT_NODE_PROC,
    "BseSource+set-automation", 
    NULL,
    "/Methods/BseSource/General/Set Automation",
    NULL,
    __enode_set_automation__fill_strings,
  },
  0, set_automation_setup, set_automation_exec, 
};
static void
__enode_get_automation_channel__fill_strings (BseExportStrings *es)
{
  es->blurb = "Get MIDI channel from an automation property.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 723;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_automation_channel = {
  { (BseExportNode*) &__enode_set_automation, BSE_EXPORT_NODE_PROC,
    "BseSource+get-automation-channel", 
    NULL,
    "/Methods/BseSource/General/Get Automation Channel",
    NULL,
    __enode_get_automation_channel__fill_strings,
  },
  0, get_automation_channel_setup, get_automation_channel_exec, 
};
static void
__enode_get_automation_control__fill_strings (BseExportStrings *es)
{
  es->blurb = "Get control type from an automation property.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 752;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_automation_control = {
  { (BseExportNode*) &__enode_get_automation_channel, BSE_EXPORT_NODE_PROC,
    "BseSource+get-automation-control", 
    NULL,
    "/Methods/BseSource/General/Get Automation Control",
    NULL,
    __enode_get_automation_control__fill_strings,
  },
  0, get_automation_control_setup, get_automation_control_exec, 
};
static void
__enode_is_prepared__fill_strings (BseExportStrings *es)
{
  es->blurb = "Check whether a source is prepared for synthesis processing.";
  es->file = "/opt/src/beast/bse/bsesource.proc";
  es->line = 781;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_is_prepared = {
  { (BseExportNode*) &__enode_get_automation_control, BSE_EXPORT_NODE_PROC,
    "BseSource+is-prepared", 
    NULL,
    "/Methods/BseSource/General/Is Prepared",
    NULL,
    __enode_is_prepared__fill_strings,
  },
  0, is_prepared_setup, is_prepared_exec, 
};
extern "C" BseExportNode* bse__builtin_init_bsesource_genprc_cc (void)
{
  return (BseExportNode*) &__enode_is_prepared;
}

/*
 * Generated data ends here
 */
